#include "compass.h"
#include <vector>
#include <cstdlib>
#include <cstdio>
using namespace std;

namespace {

const char token[] = "Ok.";

struct Reader {
	int read() { int x; scanf("%d", &x); return x; }
};

Reader IO;

const int maxn = 1e5 + 5;

int n, e = -1, a, b, c;
vector<int> T[maxn], abpath;
int ans[maxn];
bool bad = false;

bool dfs(int x, int f, int t) {
	if (x == t) return true;
	for (auto y : T[x]) {
		if (y == f) continue;
		abpath.push_back(y);
		if (dfs(y, x, t)) return true;
		abpath.pop_back();
	}
	return false;
}

void dfsB(int x, int c) {
	ans[x] = c;
	for (int y : T[x]) {
		if (ans[y]) continue;
		dfsB(y, c);
	}
}

void init() {
	n = IO.read();
	vector<pair<int, int>> E;
	for (int i = 1; i < n; ++i) {
		int x = IO.read(), y = IO.read();
		T[x].push_back(y);
		T[y].push_back(x);
		E.push_back({x, y});
	}

	a = IO.read();
	b = IO.read();
	if (a > b) swap(a, b);

	c = IO.read();
	abpath.push_back(a);
	dfs(a, -1, b);
	for (int x : abpath) ans[x] = x;
	for (int x : abpath) dfsB(x, x);

	solve(n, E);
}
}

int set_limit(int e_) {
	if (e_ < 0 || e_ > n) {
		bad = true;
		return -1;
	}
	e = e_;
	return c;
}

int query(int u) {
	static int cnt = 0;
	if (e == -1) {
		bad = true;
		return -1;
	}

	if (u < 1 || u > n) {
		bad = true;
		return -1;
	}

	cnt += 1;
	if (cnt > e) {
		bad = true;
		return -1;
	}

	return ans[u];
}

void answer(int a_, int b_) {
	if (bad) {
		puts("Invalid Query or Operation.");
		goto QUIT;
	}

	if (a != a_) {
		printf("a should be %d rather than %d.\n", a, a_);
		goto QUIT;
	}

	if (b != b_) {
		printf("b should be %d rather than %d.\n", b, b_);
		goto QUIT;
	}

	printf("%d\n", e);
	printf("%s\n", token);
	QUIT:
	exit(0);
}

int main() {
	init();
	puts("answer() not called!");
	return -1;
}
